#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>  
#include <errno.h>    
#include <netinet/in.h>  
#include <fcntl.h>  
#include <netdb.h>
#include <tcl.h>
#include <tk.h>
#include <tix.h>
#include <time.h>     
#include <signal.h>     

#define MASTERPORT  41999
 
//struct sockaddr_in mySocketAddress,masterSocketAddress;
int port,masterPort=MASTERPORT;
int mySocket,masterSocket;
char binPath[1024],terminHost[256];
char curUserName[32], curPasswd[32];
int socketsUp=false;


int send2Socket(int socket,char *msg);
int openSocket(char *host,int port);
char *wait4Message(int socket, char *t,int l);
void startTCL (int argc, char *argv[] );
int initApsh(Tcl_Interp *interp);
int transfer(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
int weekDayByDate(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
int currentTime(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
int closeSocket (ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
int closeSocket ();
int closeApp(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
void closeApp(int val);
int reconnect(Tcl_Interp *interp);
int currentDateTime(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
int timeBetween(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
int setTagList(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
int getTag(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
int getBinPath(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
char *nextElement(char *t);
char *skip2NonWS(char*t);


char tclMsg[16384];
int verbose=false;
typedef struct
{
 int x0,y0,x1,y1;
 char tag[64];
}canvasTags;

canvasTags *canvasList[8]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
int canvasListLength[8];

int main(int argc, char *argv[])
{
 char buffer[16384],*p,*p2=NULL,*p3=NULL,file[1024],*t,*s;
 int off=0,ac;
 FILE *fp;
 int useTestBin=false;
 char testBinPath[1024];

 off=0;
 ac=1;
 while(ac <argc)
  {
   if(strcmp(argv[ac],"-v")==0)
    {
     verbose=true;
     off++;
     //     argc--;
    }
   else if (strcmp(argv[ac],"-bin")==0)
    {
     useTestBin=true;
     ac++;
     strcpy(testBinPath,argv[ac]);
     off++;
     off++;
    }
   else
    break;
   ac++;
  }
 argc -= off;
 
 strcpy(binPath,"");
 strcpy(terminHost,"");

 fp=fopen("/etc/minkowsky","r");
 if(fp!=NULL)
  {
   p=fgets(buffer,8190,fp);
   while(p!=NULL)
    {
     if(strncmp(buffer,"MINKO_PATH",10)==0)
      {
       t=skip2NonWS(buffer+11);
       s= t+strlen(t)-1;
       if(*s=='\n')
	*s='\0';
       sprintf(binPath,"%s/client",t);
      }
     else if (strncmp(buffer,"MINKO_SERVER",12)==0)
       {
       t=skip2NonWS(buffer+13);
       s= t+strlen(t)-1;
       if(*s=='\n')
	*s='\0';
       strcpy(terminHost,t);
      }
     p=fgets(buffer,8190,fp);
   
    }
  }


 p=getenv("MINKO_PATH");
 if(p==NULL)
   p=getenv("TERMIN_BIN_PATH");

 if(p!=NULL)
  {
   p[strlen(p)-1]='\0';
   t=strrchr(p,'/');
   *t='\0';
  }

 if(p!=NULL)
  if(binPath[0]=='\0')
   sprintf(binPath,"%s/client",p);

 // printf("p=%p, binPath=%s\n",p,binPath);

 p=getenv("MINKO_SERVER");
 if(p==NULL)
  p=getenv("TERMIN_HOST");
 
 if(p!=NULL)
  if(terminHost[0]=='\0')
   strcpy(terminHost,p);
 if(terminHost[0]=='\0')
  strcpy(terminHost,"localhost");


 if(useTestBin)
  {
   strcpy(binPath,testBinPath);
  }
 
 

 signal(SIGTERM,closeApp);  
 signal(SIGINT ,closeApp);  
 
 startTCL(argc,argv+off);

}

int logIntoServer(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{
 char cmd[256],buffer[16384];

 strncpy(curUserName,argv[1],31);
 curUserName[31]='\0';
 strncpy(curPasswd,argv[2],31);
 curPasswd[31]='\0';


#ifdef OLD
 masterSocket= masterSocket=openSocket(terminHost,MASTERPORT);
 sprintf(cmd,"req port %s %s",argv[1],argv[2]);
 send2Socket(masterSocket,cmd);
 wait4Message(masterSocket,buffer,16383);
 if(verbose)
  printf("Got %s from %s \n",buffer,terminHost);
 if ( strcmp(buffer,"denied")==0)
  {
   interp->result="Error: {Keine Zugangsberechtigung}";
   return TCL_OK;
  }
 if ( strcmp(buffer,"noResource")==0)
  {
   interp->result="Error {Server berlastet}";
   return TCL_OK;
  }
 if ( strcmp(buffer,"noConnection")==0)
  {
   interp->result="Error (Port berlastet)}";
   return TCL_OK;
  }
 port =atoi(buffer);
 if(port<MASTERPORT)
  {
   fprintf(stderr,"Can't establish connection (%d)\n",port);
   sprintf(tclMsg,
	   "FATAL ERROR: Die Verbindung zum Termin-Server kann nicht aufgebaut werden.\n (Server '%s' down?)",
	   terminHost);
   interp->result=tclMsg;
   return TCL_OK;
  }
 usleep(100000);
 mySocket=openSocket(terminHost,port);
#else
 mySocket= masterSocket=openSocket(terminHost,MASTERPORT);
 sprintf(cmd,"connect %s %s",argv[1],argv[2]);
 send2Socket(mySocket,cmd);
 wait4Message(mySocket,buffer,16383);
 if(verbose)
  printf("Got %s from %s \n",buffer,terminHost);
 if ( strcmp(buffer,"denied")==0)
  {
   interp->result="Error: {Keine Zugangsberechtigung}";
   return TCL_OK;
  }
 if ( strcmp(buffer,"noResource")==0)
  {
   interp->result="Error {Server berlastet}";
   return TCL_OK;
  }
 if ( strcmp(buffer,"noConnection")==0)
  {
   interp->result="Error (Port berlastet)}";
   return TCL_OK;
  }
 
#endif
 send2Socket(mySocket,"client connected");
 wait4Message(mySocket,buffer,16383);
 interp->result="OK";
 socketsUp=true;
 return TCL_OK;
}
int reconnect(Tcl_Interp *interp)
{
 char cmd[256],buffer[16384];


 fprintf(stderr,"Can't establish connection (%d)\n",port);
 sprintf(tclMsg,
	 "FATAL ERROR: Die Verbindung zum Termin-Server kann nicht wieder aufgebaut werden.\n (Server '%s' down?)",
	 terminHost);
 interp->result=tclMsg;
 return TCL_OK;



 if(verbose)
  printf("trying reconnect\n");
 masterSocket= masterSocket=openSocket(terminHost,MASTERPORT);
 sprintf(cmd,"req port %s %s",curUserName,curPasswd);
 send2Socket(masterSocket,cmd);
 wait4Message(masterSocket,buffer,16383);
 if(verbose)
  printf("Got %s from %s \n",buffer,terminHost);
 if ( strcmp(buffer,"denied")==0)
  {
   interp->result="Error: {Verbindung zum Server kann nicht wieder aufgebaut werden\nKeine Zugangsberechtigung}";
   fprintf(stderr,"Error: {Verbindung zum Server kann nicht wieder aufgebaut werden\nKeine Zugangsberechtigung}");
   return TCL_OK;
  }
 if ( strcmp(buffer,"noResource")==0)
  {
   interp->result="Error {Verbindung zum Server kann nicht wieder aufgebaut werden\nServer berlastet}";
   return TCL_OK;
  }
 port =atoi(buffer);
 if(port<MASTERPORT)
  {
   fprintf(stderr,"Can't establish connection (%d)\n",port);
   sprintf(tclMsg,
	   "FATAL ERROR: Die Verbindung zum Termin-Server kann nicht wieder aufgebaut werden.\n (Server '%s' down?)",
	   terminHost);
   interp->result=tclMsg;
   return TCL_OK;
  }
 usleep(100000);
 mySocket=openSocket(terminHost,port);
 send2Socket(mySocket,"client connected");
 wait4Message(mySocket,buffer,16383);
 interp->result="OK";
}

int openSocket(char *master,int port)
{
 struct hostent     *he;
 struct sockaddr_in  server;
 int ret;
 int lsocket;

 lsocket=socket(AF_INET,SOCK_STREAM,0);

 if ((he = gethostbyname(master)) == NULL)
  {
   puts("error resolving hostname..");
   exit(1);
  }

 memcpy(&server.sin_addr, he->h_addr_list[0], he->h_length);
 server.sin_family = AF_INET;
 server.sin_port = htons(port);

 ret=connect(lsocket, (struct sockaddr *)&server, sizeof(server));
 return(lsocket);
}
 
int send2Socket(int socket,char *msg)
{
 int ret;
 ret=send(socket,msg,strlen(msg)+1,0);
 return(ret);
}
char *wait4Message(int socket, char *t,int l)
{
 int ret,tl,rt=3;
 char *s;
 
 *t='\0';
 ret=0;
 // printf("tl=%d\n",l);
 tl=0;
 for(;; )
  {
   ret =recv(socket,t+tl,l-tl,0);
   //   printf("ret=%d\n",ret);
   if(ret>0)
    {
     tl+=ret;
     //     tl--; //(null char abtrennen)
     s= t+tl-4;
     //     printf("\n+++++++++++++++++++++++++++++msg='%s' \t TERM='%s'\n",t,s);
     if(s[0]=='E')
      if(s[1]=='O')
       if(s[2]=='T')
	{
	 //	 printf("goet term\n");
	 break;
	}
    }
   else
    {
     rt--;
     if(rt==0)
      break;
    }
  }
 if(ret>0)
  {
   //   printf("got '%s'\n",t);
   *s='\0';
   return(t);
  }
 return(NULL);
}

void startTCL (int argc, char *argv[] )
{
 char *cp[16],cmd[256],path[256];
 int count=2,i;

 
 cp[0]="run";
 sprintf(cmd,"%s/main.tcl",binPath);
 cp[1]=cmd;
 for(i=1;i<argc; i++)
  {
   cp[i+1] =argv[i];
   count++;
  }
 //rintf("starting %s %s\n\n\n",cp[0],cp[1]);
 Tk_Main(count,cp,initApsh);
}

int initApsh(Tcl_Interp *interp)
{
 Tcl_Command token;
 if (Tcl_Init(interp) == TCL_ERROR) {
  return TCL_ERROR;
 }
 if (Tk_Init(interp) == TCL_ERROR) {
  return TCL_ERROR;
 }
//  if (Blt_Init(interp) != TCL_OK) {
//   return TCL_ERROR;
//  }
 if (Tix_Init(interp) == TCL_ERROR) {
  return TCL_ERROR;
 }
 Tcl_CreateCommand(interp,"transfer"    ,transfer    ,(ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"login"    ,logIntoServer,(ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"request"    ,transfer,(ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"weekDayByDate",weekDayByDate,(ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"currentTime",currentTime,(ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"currentDateTime",currentDateTime,(ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"timeBetween",timeBetween,(ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"closeSocket",closeSocket,(ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"closeApp",closeApp,(ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"setTagList",setTagList ,(ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"getTag",getTag ,(ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"getBinPath",getBinPath ,(ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);

 return TCL_OK;
}

int transfer(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{
 char buffer[500000],inp[16384],*t,*s;
 int i;

 if(!socketsUp)
  reconnect(interp);

 send2Socket(mySocket,"ServerUp?");
 wait4Message(mySocket,inp,500000);
 if(strcmp(inp,"ServerIsUp")!=0)
  {
   socketsUp =false;
   closeSocket();
   fprintf(stderr,"Server down\n");
   interp->result="ServerDown : Die Verbindung zum Termin-Server ist unterbrochen";
   return TCL_OK;
  }


 strcpy(buffer,"");
 for(i=1;i<argc;i++)
  {
   if(strlen(argv[i])==0)
    strcat(buffer,"{ } ");
   else
    {
     t=strchr(argv[i],' ');
     if(t!=NULL)
      strcat(buffer,"{");
     strcat(buffer,argv[i]);
     if(t!=NULL)
      strcat(buffer,"}");
     strcat(buffer," ");
    }
  }
 strcat(buffer," ");
 if(verbose)
  printf("sending //%s//\n",buffer);
 send2Socket(mySocket,buffer);
 wait4Message(mySocket,inp,16383);
 if(verbose)
  printf("got: %s\n",inp);
 interp->result=inp;
 return TCL_OK;
}


int weekDayByDate(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{
 struct tm tm,*tmp;
 int tim;

 tm.tm_mday = atoi(argv[1]);
 tm.tm_mon  = atoi(argv[2])-1;
 tm.tm_year = atoi(argv[3])-1900;
 tm.tm_hour = 12;
 tm.tm_min  =tm.tm_sec =0;
 tmp=&tm;
 tim = mktime(&tm);
 tmp =localtime((const time_t *)&tim);
 sprintf(interp->result,"%d",(tmp->tm_wday+6) %7);
 return(TCL_OK);
}
int currentTime(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{
 sprintf(interp->result,"%d",time(NULL));
 return TCL_OK;
}
int currentDateTime(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{
 time_t tim=time(NULL);
 strftime(tclMsg,255,"%Y%m%d %H %M",localtime(&tim));0;   
 interp->result = tclMsg;
 return TCL_OK;
}
int timeBetween(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{
 int startD,startT,stopD,stopT;
 int start,stop,delta;
 struct tm tm;

 startD = atoi(argv[1]);
 startT = atoi(argv[2]);
 stopD  = atoi(argv[3]);
 stopT  = atoi(argv[4]);
 
 tm.tm_mday = startD % 100;
 tm.tm_mon  = ((startD-tm.tm_mday)/100)%100;
 tm.tm_year = (startD-100*tm.tm_mon-tm.tm_mday)/10000 -1900;
 tm.tm_min  = startT %100;
 tm.tm_hour = (startT-tm.tm_min)/100; 
 tm.tm_sec  = 0;
 tm.tm_isdst= -1;
 start      = mktime(&tm);

 if(startD>0)
  {
   tm.tm_mday = stopD % 100;
   tm.tm_mon  = ((stopD-tm.tm_mday)/100)%100;
   tm.tm_year = (stopD-100*tm.tm_mon-tm.tm_mday)/10000 -1900;
   tm.tm_min  = stopT %100;
   tm.tm_hour = (stopT-tm.tm_min)/100;
   tm.tm_sec  = 0;
   tm.tm_isdst= -1;
   stop      = mktime(&tm);
  }
 else
  stop =time(NULL);

 delta = stop-start;
 sprintf(interp->result,"%d",delta);
 return TCL_OK;
}

int checkServer(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{
 char *t;
 t=wait4Message(mySocket,tclMsg,16383);
 interp->result=tclMsg;
 return TCL_OK;
}


int closeSocket (ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{
 closeSocket();
 return TCL_OK;
}
int closeSocket ()
{
 int ret;
 ret = close(mySocket);
 if(verbose)
  printf("mysocket closed ret=%d\n",ret);
 ret = close(masterSocket);
 if(verbose)
  printf("sockets closed ret=%d\n",ret);

}

int closeApp(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{
 closeApp(0);
 return TCL_OK;
}
void closeApp(int value)
{
 send2Socket(mySocket,"exit");

 closeSocket();
 if(verbose)
  printf("Terminator-Client terminates %d\n",value);
 usleep(500000);
 exit(0);
}
int getTag(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{
 int x,y,i,id;

 id = (atoi(argv[1]) % 8);
 x=atoi(argv[2]);
 y=atoi(argv[3]);
 // printf("look on List %d (len=%d) for (%d %d)",id,canvasListLength[id],x,y);
 for(i=0;i<canvasListLength[id]; i++)
  {
//    printf("testing %s=(%d %d %d %d_ for (%d %d)\n",canvasList[id][i].tag,
// 	  canvasList[id][i].x0,canvasList[id][i].y0,canvasList[id][i].x1,canvasList[id][i].y1,x,y);
   if(canvasList[id][i].x0<=x)
    if(canvasList[id][i].y0<=y)
     if(x<=canvasList[id][i].x1)
      if(y<=canvasList[id][i].y1)
       {
// 	printf("Thats it '%s'\n",canvasList[id][i].tag);
	interp->result=canvasList[id][i].tag;
	return TCL_OK;
       }
  }
 interp->result="-";
 return TCL_OK;
}
int getBinPath(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{
 strcpy(interp->result,binPath);
 return TCL_OK;
}
int setTagList(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{
 // usages id anz list
 // list-elem = {tag x0 y0 x1 y1}
 int anz,i,id;
 char *t,*s;
 
 id = (atoi(argv[1]) % 8);

 anz = atoi(argv[2]);
 if ( canvasList[id] !=NULL)
  delete canvasList[id];
 canvasList[id] = new canvasTags [anz];
 t= argv[3];
 //  printf("new TagList on id=%d : '%s'\n",id,t);
 for(i=0;i<anz ; i++)
  {
   s=t;
   t=nextElement(t);
   strcpy(canvasList[id][i].tag,s);

   s=t;
   t=nextElement(t);
   canvasList[id][i].x0 = atoi(s);
   s=t;
   t=nextElement(t);
   canvasList[id][i].y0 = atoi(s);
   s=t;
   t=nextElement(t);
   canvasList[id][i].x1 = atoi(s);
   s=t;
   t=nextElement(t);
   canvasList[id][i].y1 = atoi(s);
  }

 canvasListLength[id]=anz;
 return(TCL_OK);
}

char *nextElement(char *t)
{
 char *p;

 while (*t== ' ')
  t++;
 p=strchr(t,' ');
 if(p != NULL)
  *p='\0';
 return(p+1);
}

char *skip2NonWS(char*t)
{
 while(*t==' ' ||*t=='\t')
  t++;
 return(t);
}
