#! /bin/sh 

if [ "$1" == "-withVersionControl" ]
then
    WITHVERSION=1
else
    WITHVERSION=0
fi
    

echo
echo "STARTE MINKOWSKY-CLIENT-INSTALLTIONS"*
echo


#Erstelle lokale libVersion.sh
cc findLibVersion.cc  -o findTclTkLibVersion
echo "#!/bin/sh" > libVersion.sh
echo "./findTclTkLibVersion | gawk '{printf(\"tcl%s tk%s tix%s\n\",\$1,\$2,\$3)}'" >>libVersion.sh
chmod a+rx libVersion.sh




echo -n "Suche TCL/Tk/Tix-Libs                "
TCLLIB=`./libVersion.sh`
TCLOK=`echo $TCLLIB | awk '{if(NF==3){print "OK"}else{print "error"}}'`
if [ "$TCLOK" != "OK" ]
then
    echo
    echo "ERROR"
    echo "Ich kann eine der bentigten Bibliothekne nicht finden"
    echo "Es mssen TCl, TK und Tix installiert sein"
    exit
fi
echo "done"

echo -n "berprfe TCL/TL/Tix-LibsVersionen    "
TCLVER=`echo $TCLLIB |sed -e 's/[a-z]//g'|sed -e 's/\.//g'`
TCLOK=`echo $TCLVER | awk '{n=$1;while(n<1000){n=n*10;}; if(n>=8000){print "OK"}else{print "error"}}'`
echo  -n "."
TK_OK=`echo $TCLVER | awk '{n=$2; while(n<1000){n=n*10}; if(n>=8000){print "OK"}else{print "error"}}' `
echo  -n "."
TIXOK=`echo $TCLVER | awk '{n=$3; while(n<1000){n=n*10}; if(n>=4180){print "OK"}else{print "error"}}' `
echo "."

if [ "$TCLOK" != "OK" ]
then
    echo
    echo "WARNUNG"
    echo "======="
    echo
    echo "Minkowsky wurde mit TCL 8.0 entwickelt."
    echo "Ob es auch mit TCL <8.0 funktioniert ist unbekannt"
    echo "Sie knnen die Installation gerne fortsetzen und es ausprobieren"
    echo -n "    Fortsetzen  [n] "
    read ans
    echo $ans
    ANS=`echo $ans |awk '{if($1=="j" || $1=="J" ||$1=="y" ||$1=="Y"){print "OK"}else{print "stop"}}'`
    if [ "$ANS" != "OK" ]
    then
	exit
    fi
fi

if [ "$TK_OK" != "OK" ]
then
    echo
    echo "WARNUNG"
    echo "======="
    echo
    echo "Minkowsky wurde mit TK 8.0 entwickelt."
    echo "Ob es auch mit TK <8.0 funktioniert ist unbekannt"
    echo "Sie knnen die Installation gerne fortsetzen und es ausprobieren"
    echo -n "    Fortsetzen  [n] "
    read ans
    echo $ans
    ANS=`echo $ans |awk '{if($1=="j" || $1=="J" ||$1=="y" ||$1=="Y"){print "OK"}else{print "stop"}}'`
    if [ "$ANS" != "OK" ]
    then
	exit
    fi
fi

if [ "$TIXOK" != "OK" ]
then
    echo
    echo "WARNUNG"
    echo "======="
    echo
    echo "Minkowsky wurde mit Tix 4.1.8.0 entwickelt."
    echo "Ob es auch mit Tix <4.1.8.0 funktioniert ist unbekannt"
    echo "Sie knnen die Installation gerne fortsetzen und es ausprobieren"
    echo -n "    Fortsetzen  [n] "
    read ans
    echo $ans
    ANS=`echo $ans |awk '{if($1=="j" || $1=="J" ||$1=="y" ||$1=="Y"){print "OK"}else{print "stop"}}'`
    if [ "$ANS" != "OK" ]
    then
	exit
    fi
fi

echo
echo

echo -n "Installation-Pfad [/opt/minkowsky]   "
read ans
INSTALL_PATH=`echo $ans|awk '{if(NF>=1){print $1}else{print "/opt/minkowsky"}}'`
echo 
echo "Der Installer legt in ein das eigentliche Programm (bzw. ein"
echo "symbolischen Link)in ein BIN-Verzeichnis. Diese muss in der"
echo "Environment-Variable PATH stehen."
echo -n "Installation-Pfad [/usr/bin]           "
read ans
BIN_DIR=`echo $ans|awk '{if(NF>=1){print $1}else{print "/usr/bin"}}'`

echo 
echo "Die Termin usw. werden nicht vom Minkowsky-Client sondern"
echo "vom Server verwaltet. Der Minkowsky-client muss aber wissen"
echo "wo der Minkowsky-Server luft. Wenn Minkowsky nicht in einem "
echo "Netzwerk arbeitet, luft der Server auf demselben Rechner wie"
echo "der client in diesem Fall ist der Server der 'localhost'"
echo "Wenn Minkowsky in einem Netzwerk arbeitet, muss nun noch"
echo "der Name oder die IP des Minkowsky-Server angegeben werden"
echo
echo -n "Name (oder IP) des Rechners auf dem der Minkowsky-Server luft [localhost] ? "
read ans
SERVER=`echo $ans|awk '{if(NF>=1){print $1}else{print "localhost"}}'`


echo
echo
echo "Installationverzeichnis  : $INSTALL_PATH"
echo "Programm-Bin-)Verzeichnis: $BIN_DIR"
echo "Minkowsky-Server         : $SERVER"
echo
echo -n "Stimmen diese Angaben  [j] "
read ans
OK=`echo $ans|awk '{if(NF>=1){if($1=="j" ||$1=="J" ||$1=="y" ||$1=="Y"){print "OK"}else {print "new"}}else{print "OK"}}'`
echo $OK
if [ "$OK" != "OK" ]
then
    echo
    echo "OK. Versuchen wir es noch einmal"
    echo
    echo
    if [ $WITHVERSION -eq 1 ]
    then
	./installer.sh -withVersionControl
    else 
	./installer.sh
    fi
    exit
fi

echo
echo "creating Makefile"

echo "INSTALL_DIR=$INSTALL_PATH/client" >Makefile
echo "DOCU_DIR=$INSTALL_PATH/html" >>Makefile
echo "BIN_DIR=$BIN_DIR" >>Makefile
echo >>Makefile
if [ $WITHVERSION -eq 1 ]
then
    cat Makefile.wv >>Makefile
    cp -f findTclTkLibVersion $INSTALL_PATH/client/
    #Bearbeiet minkowesky-Skript wenn ntig
    echo "#!/bin/sh" > m.sh
    echo "VERSIONS=\`$INSTALL_PATH/client/findTclTkLibVersion |gawk '{printf(\"%s-%s-%s\n\",\$1,\$2,\$3)}'\`">> m.sh
    echo "$INSTALL_PATH/client/client-\$VERSIONS \$*">> m.sh
    mv -f  m.sh minkowsky
    chmod a+rx minkowsky
else 
    cat Makefile.ov >>Makefile
fi


echo
echo "making binary and installing TCl-Sckripts"

if [ -f ./client ]
then
    rm client
fi

make install

if [ -f /etc/minkowsky ]
then
    cat /etc/minkowsky |grep -v MINKO > /tmp/minkowsky
else
    touch /tmp/minkowsky
fi

echo
echo "making Configuration-file"

echo MINKO_PATH $INSTALL_PATH >> /tmp/minkowsky
echo MINKO_SERVER $SERVER  >> /tmp/minkowsky

mv -f  /tmp/minkowsky /etc/minkowsky 
chmod a+r /etc/minkowsky 

echo
echo
echo "Installation des Minkowsky-Clients abgeschlossen"
echo
exit
