proc check4NewLists { } {
    global lastListUpdate 
    global userList groupList roomList fullUserNameList
    global extList username
    global fullUserNames
    global holidays holidayNames holidayMonth

    set t [request lastUListUpdate]
    if { [string first $t "ServerDown"] >=0 } {ServerDownDialog}
    if { $t > $lastListUpdate } {
	set lastUserList 0
	set lastGroupList 0
	set lastRoomList 0
	set lastListUpdate $t

	set ret [ request getLists]
	if { [string first $ret "ServerDown"] >=0 } {ServerDownDialog}

	set userList  [lindex $ret 0]
	set groupList [lindex $ret 1]
	set roomList  [lindex $ret 2]
	set fullUserNameList [lindex $ret 3]
	set hlist [lindex $ret 4]

	set anz [llength $userList]
	for {set i 0} { $i < $anz } {incr i} {
	    set name [lindex $userList $i]
	    set fullUserNames(u-$name) [lindex $fullUserNameList $i]
	}
	set anz [llength $groupList]
	for {set i 0} { $i < $anz } {incr i} {
	    set name [lindex $groupList $i]
	    set fullUserNames(g-$name) "Gruppe $name"
	}

	set holidayMonth ""
	foreach list  $hlist {
	    set anz [llength $list]
	    if {$anz <2} { break }

	    set tag [ format "%04d-%02d" [lindex $list 0] [lindex $list 1]]
	    set holidays($tag) ""
	    set holidayNames($tag) ""
	    for {set i 2} { $i < $anz } {incr i} {
		lappend holidays($tag) [lindex $list $i]
		incr i
		lappend holidayNames($tag) [lindex $list $i]
	    }
	    lappend holidayMonth $tag
	}
    }
    set ret [request getBriefAdrList $username]
    if { $ret != "unchanged" } { set extList $ret}
}

proc getLists { } {check4NewLists }
proc getUserList { } {check4NewLists }
proc getGroupList { } {check4NewLists }
proc getRoomList { } {check4NewLists }

proc getFullUserName { name ig} {
    global userList fullUserNameList
    
#     puts "getFullUsername for $name/$ig"
#     puts "userList = $userList"
#     puts "fullList = $fullUserNameList"

    if { $ig == "u" } {
	set idx [lsearch $userList $name ]
	if { $idx>=0 } {
	    return [ lindex $fullUserNameList $idx ]
	}
    } elseif { $ig == "g" } {
	set idx [lsearch $groupList $name ]
	if { $idx>=0 } {
	    return "Gruppe $name"
	}
    }
    return "-"
}

proc date2lstr { datum } {
#    puts "Datum : /$datum/"
    set year [expr $datum /10000 ]
    set mon  [expr ($datum /100) % 100 ]
    set day  [expr $datum %100 ]

    return [format "%2d.%2d.%4d" $day $mon $year]
}
proc date2list  { datum } {
    set year [expr $datum /10000 ]
    set mon  [expr ($datum /100) % 100 ]
    set day  [expr $datum %100 ]

    return [format "%2d %2d %4d" $day $mon $year]
}

proc strTrunc { str l } {
    set len [string length $str ]
    if {$len >$l} {
	set str [format "%s..." [string range $str 0 [expr $l-4] ] ]
    }
    return $str
}
proc nameStrTrunc { str l } {

    set titelElem "Dr. med. rer. nat. rer.nat. phil. pol. rer.pol.  vet. Ing. Prof. Professor"
    set len [string length $str ]
    if {$len >$l} {
	set parts [ split $str]
	set titel ""
	set titel2 ""
	set name1 ""
	set init ""
	set name2 ""
	set anz [llength $parts]
	set ta 1
	set i 1
	set wt 0
	foreach part $parts {
	    if { [string first $part $titelElem] >=0 } {
		if {$part == "Professor" } {
		    set titel "$titel Prof."
		    set titel2 "$titel2 Prof."
		} else {
		    set titel "$titel $part"
		    if {$part == "Dr." || $part == "Prof."} {
			set titel2 "$titel2 $part"
		    }
		}
		set wt 1
	    } else {
		set ta 0
		if {$i <$anz} {
		    set name1 "$name1 $part"
		    set init [format "%s %s." $init [string range $part 0 0]]
		} else {
		    set name2 "$name2 $part"
		}
	    }
	    incr i
	}
	set name1 [ string trim $name1]
	set name2 [ string trim $name2]
	set init  [ string trim $init]
	set init2 [ string range $init 0 1]
	if {$wt == 1} {
	    set titel  [ string trim $titel]
	    set titel2 [ string trim $titel2]
	    set str "$titel $init $name2"
	    if { [string length $str] <= $l } { return $str}
	    set str "$titel2 $init $name2"
	    if { [string length $str] <= $l } { return $str}
	    set str "$titel $init2 $name2"
	    if { [string length $str] <= $l } { return $str}
	    set str "$titel2 $init2 $name2"
	    if { [string length $str] <= $l } { return $str}
	    set str "$titel $name2"
	    if { [string length $str] <= $l } { return $str}
	    set str "$titel2 $name2"
	    if { [string length $str] <= $l } { return $str}
	}
	set str "$init $name2"
	if { [string length $str] <= $l } { return $str}
	set str "$init2 $name2"
	if { [string length $str] <= $l } { return $str}
	set str [format "%s..." [string range $str 0 [expr $l-4] ] ]
    }
    return $str
}

proc date2Str {str } {
    set year [expr ($str /10000) %100 ]
    set mon [expr ($str /100) % 100 ]
    set day [expr $str %100 ]
    set str [format "%2d.%2d.%02d" $day $mon $year]
    return $str
}
proc time2Str { str} { 
    set hour [expr $str /100]
    set min [expr $str %100]
    set str [format "%2d:%02d" $hour $min]
    return $str
}
